<?php

require_once("binary.php");

function decrm2(&$f,&$p,$type,$subtype,$im){
   global $err,$ms;
   switch($type){
      case 0: return "D".$subtype;
      case 1: return "A".$subtype;
      case 2: return "(A".$subtype.")";
      case 3: return "(A".$subtype.")+";
      case 4: return "-(A".$subtype.")";
      case 5: $v=getint2mac($f,$p); return sprintf("(D_%04X,A%d)",$v,$subtype);
      case 6:
         $d1=getint1($f,$p); $d2=getint1($f,$p);
         if($d1&1){
            //$err=true; return "TYPE=6 SPEC=1";
            $base=array();
            $r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
            $ss=$d2>>4&3; $ii=$d2>>6&3; $aa=$d2&3; $pp=$d2>>2&1;
            switch($ss){
               case 0: $base[]="????"; $err=true; break;
               case 1: break;
               case 2: $base[]=sprintf("D_%04X",getint2mac($f,$p)); break;
               case 3: $base[]=sprintf("D_%08X",getint4mac($f,$p)); break;
            }
            if(!($ii&2)) $base[]="A".$subtype;
            if($pp==1 and $aa) $base=array("[".implode(",",$base)."]");
            if(!($ii&1)){
               $rg=($r>>3?"A":"D").($r&7); $rg.=".";
               $rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
               $base[]=$rg;
            }
            if($pp==0 and $aa) $base=array("[".implode(",",$base)."]");
            switch($aa){
               case 2: $base[]=sprintf("D_%04X",getint2mac($f,$p)); break;
               case 3: $base[]=sprintf("D_%08X",getint4mac($f,$p)); break;
            }
            return "(".implode(",",$base).")";
         }else{
            //$err=true; return "TYPE=6 SPEC=0";
            $r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
            $rg=($r>>3?"A":"D").($r&7); $rg.=".";
            $rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
            return sprintf("(D_%02X,A%d,%s)",$d2,$subtype,$rg);
         }
      case 7:
         switch($subtype){
            case 0: $v=getint2mac($f,$p); return sprintf("A_%04X.W",$v);
            case 1: $v=getint4mac($f,$p); return sprintf("A_%08X",$v);
            case 2: $v=getint2mac($f,$p); return sprintf("(D_%04X,PC)",$v);
            case 3:
               $d1=getint1($f,$p); $d2=getint1($f,$p);
               if($d1&1){
                  $err=true; return "TYPE=7 SUBTYPE=3 SPEC=1";
               }else{
                  //$err=true; return "TYPE=6 SUBTYPE=3 SPEC=0";
                  $r=$d1>>4&15; $s=$d1>>3&1; $m=$d1>>1&3;
                  $rg=($r>>3?"A":"D").($r&7); $rg.=".";
                  $rg.=$s?"L":"W"; if($m) $rg.="*".(1<<$m);
                  return sprintf("(D_%02X,PC,%s)",$d2,$rg);
               }
            case 4:
               switch($im){
                  case "CCR": case "SR": return $im;
                  case "imm2": $v=getint2mac($f,$p); return sprintf("#0x%04X",$v);
                  case "imm4": $v=getint4mac($f,$p); return sprintf("#0x%08X",$v);
               }
            default: global $err; $err=true; return "TYPE=7 SUBTYPE=".$subtype;
         }
      default: $err=true; return "TYPE=".$type;
   }
}

function decrm(&$f,&$p,$op,$im){
   return decrm2($f,$p,$op>>3&7,$op&7,$im);
}

$sis=array(".B",".W","",".?");
function decsi($op){
   $si=$op>>6&3;
   global $sis; return $sis[$si];
}
$sis2=array("[ERROR]",".B","",".W");

function decimm($op){
   $imm=$op>>9&7;
   return $imm?$imm:8;
}

$cons=array("T","F","HI","LS","CC","CS","NE","EQ","VC","VS","PL","MI","GE","LT","GT","LE");

function regs($rs,$rv){
   $s="";
   for($i=0;$i<15;$i++){
      if($rs&($rv?0x8000>>$i:1<<$i)){
         $s.=($i>>3?"A":"D").($i&7);
      }
   }
   if($s=="") $s="NONE"; else $s="REGS ".$s;
   return $s;
}

$shs=array("AS","LS","ROX","RO");
$drs=array("R","L");
$bits=array("BTST","BCHG","BCLR","BSET");
$srs=array("CCR","SR","","");

$fn=@$argv[1] or die("Name of executable must be given in command line!");
$f=file_get_contents($fn);

$co=$f;

$threads=array();

$jumptables=array(
	array(0,0x08BA,1),
	array(0,0x0ad6,0x2B),
	array(0,0x12e2,10),
	array(0,0x2da8,1),
	array(0,0x332e,0),
	array(0,0x931c,0xF1),
	array(0,0x9494,0),
	array(0,0x9534,0),
	array(0,0x96ba,0),
	array(0,0x992a,0),
	array(0,0xa0ea,0),
	array(0,0xa968,4),
	array(0,0xba44,4),
	array(0,0xbe6e,2),
	array(0,0xccf4,0),
	array(0,0xe0ee,4),
	array(0,0xf3b2,1),
	array(0,0xf482,1),
	array(0,0x10024,6),
);

$p=0;
$sig=getint4mac($f,$p);
if($sig!==0x48550000) die("Not an x68 executable!");
$uk=getint4mac($f,$p);
$start_pc=getint4mac($f,$p);
$len_code=getint4mac($f,$p);
$len_data=getint4mac($f,$p);
$len_uninit=getint4mac($f,$p);
$len_reloc=getint4mac($f,$p);
$len_debug=getint4mac($f,$p);

$p=0x40;
$code=getstr($f,$p,$len_code);
$data=getstr($f,$p,$len_data);
$reloc=getstr($f,$p,$len_reloc);
$debug=getstr($f,$p,$len_debug);

$co=$code;

function parse_debug($f){
	global $threads,$comm;
	$p=0;
	$l=strlen($f);
	while($p<$l){
		$uk1=getint1($f,$p);
		$uk2=getint1($f,$p);
		$addr=getint4mac($f,$p);
		$name=getzstr($f,$p);
		$p+=$p&1;
		if($uk2!==0){
			$comm[0][$addr]=$name;
		}
		if($uk2===1){
			$threads[]=array(0,$addr);
		}
	}
}

parse_debug($debug);

/*
foreach($threads as $sg_p){
	list($sg,$p)=$sg_p;
	$comm[$sg][$p].="manually added entry";
}
*/

foreach($jumptables as $sg_p){
	list($sg,$p,$base)=$sg_p;
	$comm[$sg][$p]="Jumptable";
	$p0=$p;
	$min=0x7FFFFFFF;
	$ix=0;
	while(1){
		$rel=getint2mac($co,$p);
		$addr=$p0+$rel;
		if($addr<$min) $min=$addr;
		$threads[]=array($sg,$addr);
		$value="";
		if(!is_null($base)) $value=sprintf(" case 0x%0X",$base+$ix);
		if (!isset($comm[$sg][$addr])) {
			$comm[$sg][$addr]="jumptable target [from 0x".h2($p0,8)."]".$value;
		} else {
			if(strlen($value)) $comm[$sg][$addr].=",".$value;
		}
//printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! p=%X, sg=%X, addr=%X, min=%X\n",$p,$sg,$addr,$min);
		if($p>=$min) break;
		++$ix;
	}
}



$allend=false;
$dec=array();
//print_r($threads);
list($sg,$p)=array_shift($threads);
//$comm[$sg][$p]="Subroutine entry";

$sg=0;
while(!$allend){
   if(isset($dec[$sg][$p])){
      if(count($threads)==0) break;
      list($sg,$p)=array_shift($threads);
//      $comm[$sg][$p]="Subroutine entry";
//      $co=substr($f["CODE"][$sg],4);
      continue;
   }
   $line="???"; $err=false; $sa=$p;
if($p<0 or $p>=strlen($co)) $err=true;
   $op=getint2mac($co,$p);
   if(0){
   }elseif(($op&0xFF00)==0x0000){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $si=$op>>6&3;
      $v=decrm($co,$p,$op,$srs[$si]);
      $line=sprintf("OR%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xFF00)==0x0200){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $si=$op>>6&3;
      $v=decrm($co,$p,$op,$srs[$si]);
      $line=sprintf("AND%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xFF00)==0x0400){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $v=decrm($co,$p,$op,"");
      $line=sprintf("SUB%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xFFF0)==0x06C0){
      $err=true;
      $line="Unknown opcode (RTM): ".h2($op,4);
   }elseif(($op&0xFF00)==0x0600){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $v=decrm($co,$p,$op,"");
      $line=sprintf("ADD%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xFF00)==0x0800){
      $bit=$op>>6&3; $im=sprintf("#0x%04X",getint2mac($co,$p));
      $v=decrm($co,$p,$op,"");
      $line=sprintf("%s %s,%s",$bits[$bit],$im,$v);
   }elseif(($op&0xFF00)==0x0A00){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $si=$op>>6&3;
      $v=decrm($co,$p,$op,$srs[$si]);
      $line=sprintf("EOR%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xFF00)==0x0C00){
      $siz=decsi($op);
      if($siz=="") $im=sprintf("#0x%08X",getint4mac($co,$p));
         else $im=sprintf("#0x%04X",getint2mac($co,$p));
      $v=decrm($co,$p,$op,"");
      $line=sprintf("CMP%s %s,%s",$siz,$im,$v);
   }elseif(($op&0xF138)==0x0108){
      $err=true;
      $line="Unknown opcode (MOVEP): ".h2($op,4);
   }elseif(($op&0xF100)==0x0100){
      $bit=$op>>6&3; $r=$op>>9&3;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("%s D%d,%s",$bits[$bit],$r,$v);
   }elseif(($op&0xF000)==0x0000){
      $err=true;
      $line="Unknown opcode (A): ".h2($op,4);
   }elseif(($op&0xC000)==0x0000){
      $si=$op>>12&3; $siz=$sis2[$si];
      $va=decrm($co,$p,$op,$si==2?"imm4":"imm2"); $vb=decrm2($co,$p,$op>>6&7,$op>>9&7,"");
      $line=sprintf("MOVE%s %s,%s",$siz,$va,$vb);
   }elseif(($op&0xF1C0)==0x41C0){
      $v=decrm($co,$p,$op,"imm4");
      $line=sprintf("LEA %s,A%d",$v,$op>>9&7);
   }elseif(($op&0xFF00)==0x4200){
      $v=decrm($co,$p,$op,"");
      $si=decsi($op);
      $line=sprintf("CLR%s %s",$si,$v);
   }elseif(($op&0xFFC0)==0x40C0){
      $v=decrm($co,$p,$op,"");
      $line=sprintf("MOVE SR,%s",$v);
   }elseif(($op&0xFF00)==0x4000){
      $v=decrm($co,$p,$op,"");
      $si=decsi($op);
      $line=sprintf("NEGX%s %s",$si,$v);
   }elseif(($op&0xFFC0)==0x44C0){
      $err=true;
      $line="Unknown opcode (MOVE rm,CCR): ".h2($op,4);
   }elseif(($op&0xFFC0)==0x46C0){
      $v=decrm($co,$p,$op,"imm2");
      $line=sprintf("MOVE %s,SR",$v);
   }elseif(($op&0xFF00)==0x4400){
      $v=decrm($co,$p,$op,"");
      $si=decsi($op);
      $line=sprintf("NEG%s %s",$si,$v);
   }elseif(($op&0xFF00)==0x4600){
      $v=decrm($co,$p,$op,"");
      $si=decsi($op);
      $line=sprintf("NOT%s %s",$si,$v);
   }elseif(($op&0xFFF8)==0x4840){
      $line=sprintf("SWAP D%d",$op&7);
   }elseif(($op&0xFFF8)==0x4848){
      $err=true;
      $line="Unknown opcode (BKPT): ".h2($op,4);
   }elseif(($op&0xFFC0)==0x4840){
      $v=decrm($co,$p,$op,"imm4");
      $line=sprintf("PEA %s",$v);
   }elseif(($op&0xFFF8)==0x4880){
      $r=$op&7;
      $line=sprintf("EXT.W D%d",$r);
   }elseif(($op&0xFFF8)==0x48C0){
      $r=$op&7;
      $line=sprintf("EXT.L D%d",$r);
   }elseif(($op&0xFFC0)==0x48C0){
      $rs=getint2mac($co,$p); $v=decrm($co,$p,$op,"");
      $line=sprintf("MOVEM %s,%s",regs($rs,true),$v);
   }elseif(($op&0xFFC0)==0x4AC0){
      $err=true;
      $line="Unknown opcode (TAS): ".h2($op,4);
   }elseif(($op&0xFF00)==0x4A00){
      $v=decrm($co,$p,$op,"");
      $si=decsi($op);
      $line=sprintf("TST%s %s",$si,$v);
   }elseif(($op&0xFFC0)==0x4C80){
      $rs=getint2mac($co,$p); $v=decrm($co,$p,$op,"");
      $line=sprintf("MOVEM.W %s,%s",$v,regs($rs,false));
   }elseif(($op&0xFFC0)==0x4CC0){
      $rs=getint2mac($co,$p); $v=decrm($co,$p,$op,"");
      $line=sprintf("MOVEM %s,%s",$v,regs($rs,false));
   }elseif(($op&0xFFF0)==0x4E40){
      $line=sprintf("TRAP #%d",$op&15);
   }elseif(($op&0xFFF8)==0x4E50){
      $v=getint2mac($co,$p);
      $line=sprintf("LINK A%d,0x%04X",$op&7,$v);
   }elseif(($op&0xFFF8)==0x4E58){
      $line=sprintf("UNLK A%d",$op&7);
   }elseif($op==0x4E71){
      $line="NOP";
   }elseif($op==0x4E72){
      $v=getint2mac($co,$p);
      $line=sprintf("STOP #0x%04X",$v);
   }elseif($op==0x4E73){
      $line="RTE"; $err=true;
   }elseif($op==0x4E74){
      $v=getint2mac($co,$p);
      $line=sprintf("RTD #0x%04X",$v);
      $err=true;
   }elseif($op==0x4E75){
      $line="RTS"; $err=true;
   }elseif(($op&0xFFC0)==0x4E80){
      $aa=$p;
      $v=decrm($co,$p,$op,"imm2");
      $line=sprintf("JSR %s",$v);
      if(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",PC)"){
         $v=hexdec(substr($v,3,4)); if($v>>15) $v-=1<<16;
         $v+=$aa; $line.=" ; = 0x".h2($v,4);
         $threads[]=array($sg,$v);
//         $comm[$sg][$v].="Subroutine entry";
      }elseif(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",A5)"){
         $v=hexdec(substr($v,3,4)); $v=$v-0x22>>3;
         $line.=" ; = Entry 0x".h2($v,2);
      }elseif(strlen($v)==10 and substr($v,0,2)==="A_"){
         $v=hexdec(substr($v,2));
         $threads[]=array($sg,$v);
//         $comm[$sg][$v].="Subroutine entry";
      }
   }elseif(($op&0xFFC0)==0x4EC0){
      $aa=$p;
      $v=decrm($co,$p,$op,"imm2");
      $line=sprintf("JMP %s",$v);
      $err=true;
      if(strlen($v)==11 and substr($v,0,3)=="(D_" and substr($v,7,4)==",PC)"){
         $v=hexdec(substr($v,3,4)); if($v>>15) $v-=1<<16;
         $v+=$aa; $line.=" ; = 0x".h2($v,4);
         $threads[]=array($sg,$v);
      }
   }elseif(($op&0xF000)==0x6000){
      $con=$op>>8&15;
      if($con==0) $cond="RA"; elseif($con==1) $cond="SR";
         else $cond=$cons[$con];
      $v=$op&0xFF; if($v>>7) $v-=1<<8;
      $long=$v==0;
      $aa=$p;
      if($v==0){ $v=getint2mac($co,$p); if($v>>15) $v-=1<<16; }
      $si="";
      if($con==1 and !$long) $si=".S";
         elseif($con!=1 and $long) $si=".L";
      $v+=$aa;
      $line=sprintf("B%s%s B_%04X",$cond,$si,$v);
      $threads[]=array($sg,$v);
      if($con==1) $comm[$sg][$v]="Subroutine entry";
      if($con==0) $err=true;
   }elseif(($op&0xF0F8)==0x50C8){
      $con=$op>>8&15;
      $aa=$p;
      $r=$op&7; $v=getint2mac($co,$p); if($v>>15) $v-=1<<16;
      $v+=$aa;
      $line=sprintf("DB%s D%d,B_%04X",$cons[$con],$r,$v);
      $threads[]=array($sg,$v);
   }elseif(($op&0xF0C0)==0x50C0){
      $con=$op>>8&15;
      $v=decrm($co,$p,$op,"imm2");
      $line=sprintf("S%s %s",$cons[$con],$v);
   }elseif(($op&0xF100)==0x5000){
      $v=decrm($co,$p,$op,""); $im=decimm($op);
      $si=decsi($op);
      $line=sprintf("ADDQ%s #%d,%s",$si,$im,$v);
   }elseif(($op&0xF100)==0x5100){
      $v=decrm($co,$p,$op,""); $im=decimm($op);
      $si=decsi($op);
      $line=sprintf("SUBQ%s #%d,%s",$si,$im,$v);
   }elseif(($op&0xF000)==0x7000){
      $v=$op&255; $r=$op>>9&7;
      $line=sprintf("MOVEQ #0x%02X,D%d",$v,$r);
   }elseif(($op&0xF1C0)==0x80C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
      $line=sprintf("DIVU %s,D%d",$v,$r);
   }elseif(($op&0xF1C0)==0x81C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
      $line=sprintf("DIVS %s,D%d",$v,$r);
   }elseif(($op&0xF100)==0x8000){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
      $line=sprintf("OR%s %s,D%d",$si,$v,$r);
   }elseif(($op&0xF100)==0x8100){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("OR%s D%d,%s",$si,$r,$v);
   }elseif(($op&0xF1C0)==0x90C0){
      $v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
      $line=sprintf("SUBA.W %s,A%d",$v,$r);
   }elseif(($op&0xF1C0)==0x91C0){
      $v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
      $line=sprintf("SUBA %s,A%d",$v,$r);
   }elseif(($op&0xF138)==0x9100){
      $si=decsi($op); $r1=$op>>9&7; $r2=$op&7;
      $line=sprintf("SUBX%s D%d,D%d",$si,$r2,$r1);
   }elseif(($op&0xF138)==0x9108){
      $err=true;
      $line="Unknown opcode (SUBX.W): ".h2($op,4);
   }elseif(($op&0xF100)==0x9000){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
      $line=sprintf("SUB%s %s,D%d",$si,$v,$r);
   }elseif(($op&0xF100)==0x9100){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("SUB%s D%d,%s",$si,$r,$v);
   }elseif(($op&0xF000)==0xA000){
      $rts=false;
      if(($op&0x0C00)==0x0C00){
         $rts=true; $op&=0xFBFF;
      }
      if(isset($traps[$op])) $line=$traps[$op];
      else $line=sprintf("(trap %04X)",$op);
      if($rts) $line.=" + RTS"; $err=$rts;
   }elseif(($op&0xF1C0)==0xB0C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,"imm2"); 
      $line=sprintf("CMPA.W %s,A%d",$v,$r);
   }elseif(($op&0xF1C0)==0xB1C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,"imm4"); 
      $line=sprintf("CMPA %s,A%d",$v,$r);
   }elseif(($op&0xF100)==0xB000){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,$si==""?"imm4":"imm2"); 
      $line=sprintf("CMP%s %s,D%d",$si,$v,$r);
   }elseif(($op&0xF100)==0xB100){
      $si=decsi($op); $ra=$op&7; $rb=$op>>9&7;
      $line=sprintf("CMPM%s (A%d)+,(A%d)+",$si,$ra,$rb);
   }elseif(($op&0xF100)==0xB100){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("EOR%s D%d,%s",$si,$r,$v);
   }elseif(($op&0xF1C0)==0xC1C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
      $line=sprintf("MULS %s,D%d",$v,$r);
   }elseif(($op&0xF1C0)==0xC0C0){
      $r=$op>>9&7;
      $v=decrm($co,$p,$op,/*"imm4"*/"imm2"); // bug in dasm68?
      $line=sprintf("MULU %s,D%d",$v,$r);
   }elseif(($op&0xF100)==0xC000){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
      $line=sprintf("AND%s %s,D%d",$si,$v,$r);
   }elseif(($op&0xF100)==0xC100){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("AND%s D%d,%s",$si,$r,$v);
   }elseif(($op&0xF1C0)==0xD0C0){
      $v=decrm($co,$p,$op,"imm2"); $r=$op>>9&7;
      $line=sprintf("ADDA.W %s,A%d",$v,$r);
   }elseif(($op&0xF1C0)==0xD1C0){
      $v=decrm($co,$p,$op,"imm4"); $r=$op>>9&7;
      $line=sprintf("ADDA %s,A%d",$v,$r);
   }elseif(($op&0xF100)==0xD000){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,$si==""?"imm4":"imm2");
      $line=sprintf("ADD%s %s,D%d",$si,$v,$r);
   }elseif(($op&0xF138)==0xD100){
      $si=decsi($op); $r1=$op>>9&7; $r2=$op&7;
      $line=sprintf("ADDX%s D%d,D%d",$si,$r2,$r1);
   }elseif(($op&0xF138)==0xD108){
      $err=true;
      $line="Unknown opcode (ADDX.W): ".h2($op,4);
   }elseif(($op&0xF100)==0xD100){
      $si=decsi($op); $r=$op>>9&7;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("ADD%s D%d,%s",$si,$r,$v);
   }elseif(($op&0xF8C0)==0xE8C0){
      $o=$op>>8&7; $bi=getint2mac($co,$p);
      $va=$bi>>6&63; $vb=$bi&63;
      $v=decrm($co,$p,$op,"");
      if($va&32) $va="D".($va&7); else $va="#".$va;
      if($vb&32) $vb="D".($vb&7); else $vb="#".($vb?$vb:32);
      $bfs=array("BFTST %s{%s:%s}","BFEXTU %s{%s:%s},D6","BFCHG %s{%s:%s}","BFEXTS %s{%s:%s},D6",
         "BFCLR %s{%s:%s}","BFFFO %s{%s:%s},D6","BFSET %s{%s:%s}","BFINS D6,%s{%s:%s}");
      $line=sprintf($bfs[$o],$v,$va,$vb);
   }elseif(($op&0xF8C0)==0xE0C0){
      //$err=true;
      //$line="Unknown opcode (shift): ".h2($op,4);

      $sh=$op>>9&3; $dr=$op>>8&1;
      $v=decrm($co,$p,$op,"");
      $line=sprintf("%s%s %s",$shs[$sh],$drs[$dr],$v);
   }elseif(($op&0xF000)==0xE000){
      $sh=$op>>3&3; $dr=$op>>8&1;
      if($op>>5&1){
         $r="D".($op>>9&7);
      }else{
         $r="#".decimm($op);
      }
      //$v=decrm($co,$p,$op,"");
      $v="D".($op&7);
      $line=sprintf("%s%s %s,%s",$shs[$sh],$drs[$dr],$r,$v);
   }else{
      $err=true;
      $line="Unknown opcode: ".h2($op,4);
   }
   if(preg_match("/(?:A_|#0x)([0-9A-F]{8})/",$line,$match_out)){
      $addr=hexdec($match_out[1]);
      if(isset($comm[0][$addr])) $line.=" ; ".$comm[0][$addr];
   }
   $line=sprintf("%-24s %s",str2hex(substr($co,$sa,$p-$sa)),$line);
   $next[$sg][$sa]=$p;
//   if(!isset($dec[$sg][$p])) $dec[$sg][$p]="";
   if($err){
      $dec[$sg][$sa]=$line;
      if(isset($dec[$sg][$sa])){
         if(count($threads)==0) break;
         list($sg,$p)=array_shift($threads);
//         $comm[$sg][$p]="Subroutine entry";
//         $co=substr($f["CODE"][$sg],4);
         continue;
      }
   }
   $dec[$sg][$sa]=$line;
}

ksort($dec);
foreach($dec as $sg=>$sgs){
   ksort($sgs);
//   $co=substr($f["CODE"][$sg],4);
   $en=0;
   foreach($sgs as $of=>$v){
   //   if($k==$start) print "START\r\n";
      if($en!=$of) {
         print /*h2($sg,4).":".*/h2($en,8).": ";
         if($of>$en){
            print "[UNEXPLORED] ".urlencode(substr($co,$en,$of-$en))."\r\n";
         }else{
            print "NEGATIVE JUMP!\r\n";
         }
      }
      if(isset($comm[$sg][$of])){
         //$v.=" ; ".$comm[$sg][$of];
         print " ; ".$comm[$sg][$of]."\r\n";
      }
      print /*h2($sg,4).":".*/h2($of,8).": ".$v."\r\n";
      $en=$next[$sg][$of];
   }
   $of=strlen($co);
   if($en!=$of) print /*h2($sg,4).":".*/h2($en,8).": [UNEXPLORED] ".urlencode(substr($co,$en,$of-$en))."\r\n";
   print "\r\n";
}

