<?php

require_once("binary.php");

function parse_debug($f){
	$p=0;
	$l=strlen($f);
	while($p<$l){
		$uk1=getint1($f,$p);
		$uk2=getint1($f,$p);
		$addr=getint4mac($f,$p);
		$name=getzstr($f,$p);
		$p+=$p&1;
		printf("ADDR=0x%08X UK1=%02X UK2=%02X NAME=%s\r\n",$addr,$uk1,$uk2,$name);
	}
}

$fn="prince1.x";
$f=file_get_contents($fn);

$sig=getint4mac($f,$p);
if($sig!==0x48550000) die("Not an x68 executable!");

$uk=getint4mac($f,$p);
$start_pc=getint4mac($f,$p);
$len_code=getint4mac($f,$p);
$len_data=getint4mac($f,$p);
$len_uninit=getint4mac($f,$p);
$len_reloc=getint4mac($f,$p);
$len_debug=getint4mac($f,$p);

$p=0x40;
$code=getstr($f,$p,$len_code);
$data=getstr($f,$p,$len_data);
$reloc=getstr($f,$p,$len_reloc);
$debug=getstr($f,$p,$len_debug);

parse_debug($debug);
